/*
 *
 * Livewallpaper
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Copyright (C) 2012 Maximilian Schnarr <Maximilian.Schnarr@googlemail.com>
 *
 */

#ifndef _GALAXY_LIGHT_H_
#define _GALAXY_LIGHT_H_

G_BEGIN_DECLS

#define GALAXY_TYPE_LIGHT_PROGRAM            (galaxy_light_program_get_type())
#define GALAXY_LIGHT_PROGRAM(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALAXY_TYPE_LIGHT_PROGRAM, GalaxyLightProgram))
#define GALAXY_IS_LIGHT_PROGRAM(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALAXY_TYPE_LIGHT_PROGRAM))
#define GALAXY_LIGHT_PROGRAM_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), GALAXY_TYPE_LIGHT_PROGRAM, GalaxyLightProgramClass))
#define GALAXY_IS_LIGHT_PROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALAXY_TYPE_LIGHT_PROGRAM))
#define GALAXY_LIGHT_PROGRAM_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), GALAXY_TYPE_LIGHT_PROGRAM, GalaxyLightProgramClass))

typedef struct _GalaxyLightProgram GalaxyLightProgram;
typedef struct _GalaxyLightProgramClass GalaxyLightProgramClass;

typedef struct _GalaxyLightProgramPrivate GalaxyLightProgramPrivate;

struct _GalaxyLightProgram
{
	GObject parent_instance;
	
	/*< private >*/
	GalaxyLightProgramPrivate *priv;
};

struct _GalaxyLightProgramClass
{
	GObjectClass parent_class;
};

GType galaxy_light_program_get_type(void);

void galaxy_light_program_update(GalaxyLightProgram *self);


/* outer color */
void galaxy_light_program_set_outer_color(GalaxyLightProgram *self, GdkRGBA *color);
void galaxy_light_program_get_outer_color(GalaxyLightProgram *self, GdkRGBA *color);

/* inner color */
void galaxy_light_program_set_inner_color(GalaxyLightProgram *self, GdkRGBA *color);
void galaxy_light_program_get_inner_color(GalaxyLightProgram *self, GdkRGBA *color);

/* color radius */
void galaxy_light_program_set_color_radius(GalaxyLightProgram *self, gdouble radius);
gdouble galaxy_light_program_get_color_radius(GalaxyLightProgram *self);


void galaxy_light_program_enable(GalaxyLightProgram *self);

void galaxy_light_program_disable(GalaxyLightProgram *self);

G_END_DECLS

#endif /* _GALAXY_LIGHT_H_ */

